package com.landray.kmss.sys.attachment.actions;

import com.landray.kmss.web.config.IActionConfig;
import java.util.Map;
import com.landray.kmss.web.config.ForwardConfig;
import com.landray.kmss.sys.attachment.service.ISysAttComputingTimeService;
import java.util.Iterator;
import java.util.List;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.sys.attachment.model.SysAttComputingTimePlugin;
import com.landray.kmss.sys.attachment.util.SysAttComputingTimeUtil;
import net.sf.json.JSONObject;
import com.landray.kmss.util.KmssMessages;
import com.landray.kmss.common.test.TimeCounter;
import com.landray.kmss.web.action.ActionForward;
import javax.servlet.http.HttpServletResponse;
import com.landray.kmss.web.action.ActionForm;
import com.landray.kmss.web.action.ActionMapping;
import com.landray.kmss.common.service.IBaseService;
import javax.servlet.http.HttpServletRequest;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;
import com.landray.kmss.common.actions.ExtendAction;

public class SysAttComputingTimeAction extends ExtendAction
{
    private Logger logger;
    public static final String LEARN_COMPUTING_TIME = "learnComputingTime";
    
    public SysAttComputingTimeAction() {
        this.logger = LoggerFactory.getLogger(this.getClass());
    }
    
    protected IBaseService getServiceImp(final HttpServletRequest request) {
        return null;
    }
    
    public ActionForward computingTime(final ActionMapping mapping, final ActionForm form, final HttpServletRequest request, final HttpServletResponse response) throws Exception {
        TimeCounter.logCurrentTime("Action-computingTime", true, (Class)this.getClass());
        final KmssMessages messages = new KmssMessages();
        final String fdId = request.getParameter("fdId");
        final String templateId = request.getParameter("_templateId");
        final String contentId = request.getParameter("_contentId");
        JSONObject json = new JSONObject();
        try {
            final List<SysAttComputingTimePlugin> plugins = SysAttComputingTimeUtil.getExtensionList();
            if (plugins != null && plugins.size() > 0) {
                for (final SysAttComputingTimePlugin plugin : plugins) {
                    final String fdKey = plugin.getKey();
                    if (StringUtil.isNotNull(fdKey) && "learnComputingTime".equals(fdKey)) {
                        final ISysAttComputingTimeService provider = plugin.getProvider();
                        final String time = plugin.getTimeInterval().toString();
                        json = provider.updateComputingTime(fdId, templateId, contentId, time);
                    }
                }
            }
        }
        catch (final Exception e) {
            messages.addError((Throwable)e);
            this.logger.error(e.getMessage(), e);
        }
        request.setAttribute("lui-source", (Object)json);
        TimeCounter.logCurrentTime("Action-computingTime", false, (Class)this.getClass());
        return this.getActionForward("lui-source", mapping, form, request, response);
    }
}
